#include "colors.inc"
#include "textures.inc"
#include "metals.inc"   
#include "woods.inc"

camera{
   location <55,-20,145>
   look_at <70,-25,164>
   }    

   
#declare r1 = 90;  //rotate 1st segment on x
#declare r2 = 0; //rotate 2nd segment on y
#declare r3 = 0; //rotate 3rd segment on x
#declare r4 = 90;
#declare r5 = 90;
#declare r6 = 0; 

#declare l1 = 90;
#declare l2 = 0;    

#declare close = .8; //close hand, not > 1.3 
#declare extract = -4; //push out/in hand, no greater than | 10 |

#if (clock >= 1)
 #declare extract = -4 + 7*(clock-1)*2;
#end

#declare venty = superellipsoid{<.1,.1> scale <1200,70,70> translate 150*y} 

#declare bolt2 = sphere{<0,0,0>,10 scale <1,.25,1> pigment{P_Chrome2}}
#declare bolt3 = sphere{<0,0,0>,1.5 scale <1,.5,1> pigment{P_Chrome2}}                                    
#declare bolt =
 intersection{
   prism{
      linear_spline
      0,
      2,
      7,
      <1,0>,
      <0.5,0.5*pow(3,0.5)>,
      <-0.5,0.5*pow(3,0.5)>,
      <-1,0>,
      <-0.5,-0.5*pow(3,0.5)>,
      <0.5,-0.5*pow(3,0.5)>,
      <1,0>
      }
   superellipsoid{
      <0.25,1>
      rotate 90*x
      translate 1*y
      } 
   scale <1.5,1,1.5>
   pigment{P_Chrome1}
  }

#declare screw =    
 difference{
  sphere{<0,0,0>,.75 scale <1,.5,1>}
  union{
   box{<-.1,.125,1>,<.1,.5,-1>}
   box{<1,.125,-.1>,<-1,.5,.1>}
   }
  pigment{P_Chrome2}
   } 
#declare m = 0;
#declare move = 0;
#declare mr = 0;
#declare light_on = 0; 


#declare arm =  
  union{
    superellipsoid{<.25,.25> scale <1.1,1.1,10> translate <-40,42,-23>}
    superellipsoid{<.25,.25> scale <2,2,10> translate <-40,42,-33>}
    box{<-38,44,-42>,<-38.9,40,-47>} 
    box{<-42,44,-42>,<-41.1,40,-47>}
    cylinder{<-38.9,42,-47>,<-38,42,-47>,2} 
    cylinder{<-42,42,-47>,<-41.1,42,-47>,2}
    object{bolt3 rotate 90*z translate <-42,42,-47>}
    object{bolt3 rotate 90*z translate <-38,42,-47>}  
      union{
         superellipsoid{<.25,.25> scale <1.1,1.1,10> translate <-40,42,-151>}
         difference{
          superellipsoid{<.25,.25> scale <2,2,10> translate <-40,42,-161>} 
          superellipsoid{<.25,.25> scale <1.5,1.75,10> translate <-40,42,-171>}
          }                                                                    
         superellipsoid{<.1,.1> scale <1.4,.2,10> translate <-40,43.5-close,-171-extract>} 
         superellipsoid{<.1,.1> scale <1.4,.2,10> translate <-40,40.5+close,-171-extract>} 
         translate 96*z   
         ///3rd section turn
         translate <-40,42,-47>*(-1) 
         #if (clock < 1)
          rotate (-135+45*clock)*x
         #else
          rotate -90*x
         #end  
         translate <-40,42,-47>
         ///
         } 
    translate <-40,42,-15>*(-1)
    rotate 10*x
    texture{T_Chrome_1A} 
    rotate 180*y
    }

#declare alarm = 0; //turn alarm on
   
#declare key = 
 prism{
  linear_spline
  conic_sweep
  .75,
  1,
  5,
  <-3,3>,
  <-3,-3>,
  <3,-3>,
  <3,3>,
  <-3,3>
  scale <1,20,1>
  translate -15*y rotate 180*x translate 5*y
  } 
#declare arrow = 
 union{
  prism{
   linear_spline
   -.25,
   0,
   4,
   <-.5,0>,
   <.5,0>,
   <0,1>,
   <-.5,0>
   }   
  box{<-0.25,-0.25,0>,<0.25,0,-1.5>}
  }
  
#declare d_light = 0; //disk working light 

#declare doorx =
union{
union{
 box{<-70,-145,3>,<70,75,9> pigment{P_Chrome3}}
 superellipsoid{<.1,.1> translate <-1,1,0> scale <15,125+5,9> translate <-70,-160,0>}
 superellipsoid{<.1,.1> translate <1,1,0> scale <12.5,125+5,9> translate <70,-160,0>} 
 superellipsoid{<.1,.1> translate <0,1,0> scale <80,12.5,9> translate <0,75,0>}
 superellipsoid{<.25,.25> translate <0,1,0> scale <5,125+5,3> translate <-70,-160,0>}
 superellipsoid{<.25,.25> translate <0,1,0> scale <5,125+5,3> translate <70,-160,0>} 
 superellipsoid{<.25,.25> translate <0,0,0> scale <80,5,3> translate <0,75,0>}
 texture{pigment{P_Chrome2}}
 }                                                                            
union{        
  superellipsoid{<1,.25> scale <10,10,2> translate <-50,-40,3>}
  cone{<-50,-40,1.9>,10,<-50,-40,-1>,5}
  difference{
   superellipsoid{<1,.25> scale <5,5,2> translate <-50,-40,-1>}
   superellipsoid{<1,.25> scale <4.5,4.5,6> translate <-50,-40,-1>} 
   }
  superellipsoid{<1,.25> scale <4,4,8> translate <-50,-40,-1>}
  sphere{<0,0,0>,8 scale <1,1,.5> translate <-50,-40,-12>}
  texture{T12}
 }
}

#declare ventx =
union{
 union{  
 difference{  
  union{
   superellipsoid{<.1,.1> scale <12.5,80,80> translate <-80,0,0>} 
   superellipsoid{<.1,.1> scale <12.5,80,80> translate <80,0,0>} 
   superellipsoid{<.1,.1> scale <12.5,80,80> translate <-240,0,0>} 
   superellipsoid{<.1,.1> scale <12.5,80,80> translate <240,0,0>}
   superellipsoid{<.1,.1> scale <12.5,80,80> translate <-400,0,0>} 
   superellipsoid{<.1,.1> scale <12.5,80,80> translate <400,0,0>}
   superellipsoid{<.1,.1> scale <600,75,75>} 
   }
  union{
   superellipsoid{<.1,.1> scale <650,70,70>}
   superellipsoid{<.1,.1> scale <50,100,50> translate -70*y}
   }
 }
 object{bolt2 rotate 90*x translate <-80,-20,-80>}
 object{bolt2 rotate 90*x translate <-80,-60,-80>}
 object{bolt2 rotate 90*x translate <80,-20,-80>}
 object{bolt2 rotate 90*x translate <80,-60,-80>}
 object{bolt2 rotate 90*x translate <-80,-20,80>}
 object{bolt2 rotate 90*x translate <-80,-60,80>}
 object{bolt2 rotate 90*x translate <80,-20,80>}
 object{bolt2 rotate 90*x translate <80,-60,80>} 
 object{bolt2 rotate 90*x translate <-240,-20,-80>}
 object{bolt2 rotate 90*x translate <-240,-60,-80>}
 object{bolt2 rotate 90*x translate <240,-20,-80>}
 object{bolt2 rotate 90*x translate <240,-60,-80>} 
 object{bolt2 rotate 90*x translate <-240,-20,80>}
 object{bolt2 rotate 90*x translate <-240,-60,80>}
 object{bolt2 rotate 90*x translate <240,-20,80>}
 object{bolt2 rotate 90*x translate <240,-60,80>}  
 object{bolt2 rotate 90*x translate <-400,-20,-80>}
 object{bolt2 rotate 90*x translate <-400,-60,-80>}
 object{bolt2 rotate 90*x translate <400,-20,-80>}
 object{bolt2 rotate 90*x translate <400,-60,-80>} 
 object{bolt2 rotate 90*x translate <-400,-20,80>}
 object{bolt2 rotate 90*x translate <-400,-60,80>}
 object{bolt2 rotate 90*x translate <400,-20,80>}
 object{bolt2 rotate 90*x translate <400,-60,80>}  
 object{bolt2 rotate 90*x translate <-560,-20,-80>}
 object{bolt2 rotate 90*x translate <-560,-60,-80>}
 object{bolt2 rotate 90*x translate <560,-20,-80>}
 object{bolt2 rotate 90*x translate <560,-60,-80>} 
 object{bolt2 rotate 90*x translate <-560,-20,80>}
 object{bolt2 rotate 90*x translate <-560,-60,80>}
 object{bolt2 rotate 90*x translate <560,-20,80>}
 object{bolt2 rotate 90*x translate <560,-60,80>}
 object{bolt2 translate <80,-80,-50>}
 object{bolt2 translate <80,-80,0>} 
 object{bolt2 translate <80,-80,50>}
 object{bolt2 translate <-80,-80,-50>}
 object{bolt2 translate <-80,-80,0>} 
 object{bolt2 translate <-80,-80,50>} 
 object{bolt2 translate <240,-80,-50>}
 object{bolt2 translate <240,-80,0>} 
 object{bolt2 translate <240,-80,50>}
 object{bolt2 translate <-240,-80,-50>}
 object{bolt2 translate <-240,-80,0>} 
 object{bolt2 translate <-240,-80,50>}   
 object{bolt2 translate <400,-80,-50>}
 object{bolt2 translate <400,-80,0>} 
 object{bolt2 translate <400,-80,50>}
 object{bolt2 translate <-400,-80,-50>}
 object{bolt2 translate <-400,-80,0>} 
 object{bolt2 translate <-400,-80,50>} 
 object{bolt2 translate <560,-80,-50>}
 object{bolt2 translate <560,-80,0>} 
 object{bolt2 translate <560,-80,50>}
 object{bolt2 translate <-560,-80,-50>}
 object{bolt2 translate <-560,-80,0>} 
 object{bolt2 translate <-560,-80,50>}
 //hinges
 superellipsoid{<.1,.1> scale <5,2.5,10> translate <-50,-72.5,-40>}
 superellipsoid{<.1,.1> scale <5,2.5,10> translate <-50,-72.5,0>}
 superellipsoid{<.1,.1> scale <5,2.5,10> translate <-50,-72.5,40>}
 superellipsoid{<1,.25> scale <2.5,2.5,10> translate <-45,-72.5,-40>}
 superellipsoid{<1,.25> scale <2.5,2.5,10> translate <-45,-72.5,0>}
 superellipsoid{<1,.25> scale <2.5,2.5,10> translate <-45,-72.5,40>} 
 pigment{P_Chrome3} 
 }
 //grating
 union{  
   //hinges
   superellipsoid{<1,.25> scale <2.5,2.5,9.5> translate <-47.5,-72.5,20>}
   superellipsoid{<1,.25> scale <2.5,2.5,9.5> translate <-47.5,-72.5,-20>}
   superellipsoid{<.1,.1> scale <5,2.5,9.5> translate <-42.5,-72.5,-20>}
   superellipsoid{<.1,.1> scale <5,2.5,9.5> translate <-42.5,-72.5,20>}
   //grate
   superellipsoid{<.1,.1> scale <4.8,2.5,49.8> translate <-37.5,-72.5,0>}
   superellipsoid{<.1,.1> scale <40,2.5,4.8> translate <5,-72.5,45>}
   superellipsoid{<.1,.1> scale <40,2.5,4.8> translate <5,-72.5,-45>}
   superellipsoid{<.1,.1> scale <4.8,2.5,49.8> translate <45,-72.5,0>}
   box{<47.5,-70,-49.8>,<49.5,-75,49.8>} 
   //bars
   cylinder{<-27.5,-72.5,-45>,<-27.5,-72.5,45>,2.5}
   cylinder{<-20,-72.5,-45>,<-20,-72.5,45>,2.5}
   cylinder{<-12.5,-72.5,-45>,<-12.5,-72.5,45>,2.5}
   cylinder{<-5,-72.5,-45>,<-5,-72.5,45>,2.5}
   cylinder{<2.5,-72.5,-45>,<2.5,-72.5,45>,2.5}
   cylinder{<10,-72.5,-45>,<10,-72.5,45>,2.5}
   cylinder{<17.5,-72.5,-45>,<17.5,-72.5,45>,2.5} 
   cylinder{<25,-72.5,-45>,<25,-72.5,45>,2.5} 
   cylinder{<32.5,-72.5,-45>,<32.5,-72.5,45>,2.5}
   cylinder{<40,-72.5,-45>,<40,-72.5,45>,2.5}
   ///
   translate <-47.5,-72.5,0>*(-1)  
   rotate -90*z
   translate <-47.5,-72.5,0>
   ///  
   pigment{P_Chrome2}
  } 
 translate <0,150,0>
} 

#declare doory = box{<-80,-160,20>,<80,85,-20> pigment{P_Chrome3}} 

  
#declare wmarble = pigment{marble
                                turbulence 0.5
                                lambda 1.5
                                omega 0.8
                                octaves 5
                                frequency 5
                                color_map { 
                                     [0.00 rgb <1,1,1>*2]
                                     [0.50 rgb <.9,.9,.9>*2]
                                     [1.00 rgb <.8,.8,.8>*2]
                                          }
                               }

#declare bmarble = pigment{marble
                                turbulence 0.5
                                lambda 1.5
                                omega 0.8
                                octaves 5
                                frequency 5
                                color_map { 
                                     [0.00 color Gray40]  
                                     [0.50 color Gray20]
                                     [1.00 color Black]
                                          } 
                               } 
                               
#declare ty = 
   intersection{
    torus{10,5}
    box{<0,-20,0>,<-20,20,20>}
    translate -10*z
    rotate -90*z   
   }   
 
#declare tz = 
   intersection{
    torus{10,3}
    box{<0,-20,0>,<-20,20,20>}
    translate -10*z
    rotate -90*z   
   } 
                     
#declare cam = 
 union{
  union{
   box{<-10,-10,0>,<10,10,-1>}
   superellipsoid{<.1,.1> scale <5,5,10> translate <0,0,-10>}
   box{<-5,-5,-15>,<-4,5,-25>} 
   box{<5,-5,-15>,<4,5,-25>}
   cylinder{<-5,0,-25>,<-4,0,-25>,5}
   cylinder{<5,0,-25>,<4,0,-25>,5}
   object{bolt3 scale <2,2,2> rotate 90*z translate <-5,0,-25>} 
   object{bolt3 scale <2,2,2> rotate 90*z translate <5,0,-25>}
   texture{T_Chrome_1A} 
  }                    
  union{
   superellipsoid{<.1,.1> scale <4,4,10> translate <0,0,-7>}
   superellipsoid{<.1,.1> scale <10,15,10> translate <0,0,-25>}
   difference{
    superellipsoid{<1,.25> rotate 90*x scale <5,6,5> translate <0,-20,-27> texture{T_Chrome_1A}}
    cylinder{<0,-14,-27>,<0,-30,-27>,3.5}
    }                                 
   cylinder{<0,-23.5,-27>,<0,-24.5,-27>,4.5 texture{Glass}}
    union{
     text{ttf "timrom.ttf" "Nick Santos" 1,0 scale <2,2,2> rotate (-90)*x translate <-5,-16,-19>}
     text{ttf "timrom.ttf" "Security Cameras" 1,0 scale <2,2,2> rotate (-90)*x translate <-7,-16,-17>}
     pigment{color White}
    }  
   merge{
    cylinder{<-7,-14,-32>,<-7,-16,-32>,1}
    sphere{<-7,-16,-32>,1}
    pigment{color rgb <.75,0,0>}
    finish{ambient 1}
    }                
   rotate 60*x
   translate <0,0,-25>
   texture{T_Chrome_3A}
  }
 }
#declare lightxx =
 union{
   union{
    sphere{<0,0,-175>,20 scale <1,.25,1>}
    cylinder{<0,0,-175>,<0,-75,-175>,6}
    sphere{<0,0,175>,20 scale <1,.25,1>}
    cylinder{<0,0,175>,<0,-75,175>,6}
    difference{
     cylinder{<0,0,-200>,<0,0,200>,50 scale <1,.75,1> translate -115*y}
     union{
      cylinder{<0,0,-195>,<0,0,195>,45 scale <1,.75,1> translate -115*y}
      box{<-100,-115,-202>,<100,-240,202>} 
      }
     } 
    texture{pigment{color rgb <1.5,1.5,1.5>}
            finish{ambient 0.35
    brilliance 2
    diffuse 0.3
    metallic
    specular 0.80
    roughness 1/20
                  }
           }
   }
   //plastic cover
   intersection{
    cylinder{<0,0,-195>,<0,0,195>,45 scale <1,.75,1> translate -115*y}
    box{<-95,-113,-195>,<90,-111,195>}
    texture{pigment{color rgbf <.8,.8,.8,.5>}
            normal{bumps .5}
            finish{
              phong .25
              phong_size 150
              reflection .1
              }
           }
    } 
   //lights
   union{
    cylinder{<20,-95,195>,<20,-95,180>,7.5}
    cylinder{<20,-95,-195>,<20,-95,-180>,7.5}
    cylinder{<-20,-95,195>,<-20,-95,180>,7.5}
    cylinder{<-20,-95,-195>,<-20,-95,-180>,7.5}
    superellipsoid{<1,.25> translate 1*z scale <15,15,10> translate <20,-95,-180>} 
    superellipsoid{<1,.25> translate 1*z scale <15,15,10> translate <20,-95,160>}
    superellipsoid{<1,.25> translate 1*z scale <15,15,10> translate <-20,-95,-180>}
    superellipsoid{<1,.25> translate 1*z scale <15,15,10> translate <-20,-95,160>}
    texture{T_Silver_3B}
    } 
   light_source{
    <0,-100,0>
    color rgb <1,1,1>*.33
    adaptive 1
    }
   light_source{
    <0,-190,0>
    color rgb <1,1,1>*.33
    shadowless
    } 
    cylinder{<-20,-95,160>,<-20,-95,-160>,14.9 pigment{color rgb <5,5,5>} finish{ambient 1} no_shadow}
    cylinder{<20,-95,160>,<20,-95,-160>,14.9 pigment{color rgb <5,5,5>} finish{ambient 1} no_shadow} 
    scale <.75,.75,.75>
  }                               

//floor
plane{y,-150  
      texture{
       pigment{checker pigment{wmarble}, pigment{bmarble} scale <80,80,80> translate <40,0,0>}
              finish{reflection .1
                     phong .5
                     phong_size 250
                     }
            }
     }
//ceiling  
  plane{y,400 inverse pigment{color Black}}
  
   
//hall walls
difference{ 
 union{
  box{<270,-155,-300>,<-270,455,-340>}
  box{<270,-155,300>,<-270,455,340>}
  box{<250,-155,340>,<270,455,-340>} 
  box{<-250,-155,340>,<-270,455,-340>}
  }                                       
 union{
  object{doory rotate 180*y translate -300*z} 
  object{venty rotate 90*y translate 180*y} 
  }
 texture{
  pigment{color White}
  normal{bumps .1}
  }
 }
object{doorx rotate 180*y translate -300*z}
object{venty rotate 90*y translate 180*y translate 124.5*z}
//rope corner
intersection{
 torus{1,.5}
 box{<0,-2,0>,<-2,2,2>}
 pigment{P_Chrome1}
 rotate -90*z
 translate <0,260,74>
 }
cylinder{<0,261,74>,<0,261,0>,.5} 

object{lightxx translate <150,400,0>} 
object{lightxx translate <-150,400,0>} 

object{cam scale <2,2,2> rotate 180*y translate <0,150,-300>} 

//desk
union{  
 union{
  box{<-150,-150,150>,<-140,-40,300>}
  box{<150,-150,150>,<140,-40,300>}  
  pigment{DMFWood4 rotate 90*y rotate 90*z scale <15,15,15>}
  } 
 box{<-75,-150,155>,<-85,-40,300>}
 box{<75,-150,155>,<85,-40,300>}  
 box{<-145,-145,155>,<-80,-40,300>}
 box{<145,-145,155>,<80,-40,300>} 
 superellipsoid{<.25,.25> scale <150,10,10> translate <0,-50,150>}
 box{<-150,-60,150>,<150,-40,300>}   
 //system shelf
 box{<-80,-100,155>,<80,-110,260>}
 box{<-80,-50,155>,<-60,-110,260>} 
 box{<80,-50,155>,<60,-110,260>}
 pigment{DMFWood4 rotate 90*y scale <17,17,17>}
 } 

//monitor
union{
 //stand
 cylinder{<0,0,0>,<0,2.5,0>,40}
 cone{<0,2.5,0>,40,<0,15,0>,(15.5*pow(2,.5)) open}
 sphere{<0,0,0>,30 scale <1,.5,1> translate <0,22.5,0>}  
 //body
 difference{
  union{   
   superellipsoid{<.25,.25> scale <45,30,50> translate <0,52.5,5>}
   superellipsoid{<.25,.25> translate <0,1,-1> scale <45,30,55> rotate 10*x translate <0,22.5,55>}  
   intersection{
    superellipsoid{<.25,1>}
    box{<-2,-2,0>,<2,2,2>}
    translate <0,1,-1> scale <48,36,100> rotate 10*x translate <0,12.5,45> 
    } 
   superellipsoid{<.25,.25> scale <48,36,10> rotate 10*x translate <0,48.5+100*sin(radians(10)),-50>}
   } 
    superellipsoid{<.25,.25> scale <40,30,15> rotate 10*x translate <0,48.5+100*sin(radians(10)),-50>}
  } 
 superellipsoid{<.25,1> scale <40,30,2> rotate 10*x translate <0,48.5+110*sin(radians(10)),-50-10*cos(radians(10))> hollow texture{pigment{rgbt <1,1,1,.7>} finish{ambient 0 diffuse 0 specular 1 roughness .001}}}
 superellipsoid{<.25,1> scale <40,30,1> rotate 10*x translate <0,48.5+105*sin(radians(10)),-50-5*cos(radians(10))> pigment{color Black}}
 light_source{<0,0,0> color rgb <.2,.2,.2> translate <0,48.5+109*sin(radians(10)),-50-9*cos(radians(10))>}                                                                                       
 scale <.9,.9,.9>                
 rotate -45*y
 translate <-80,-40,225>
 pigment{color White}
 }
 
//keyboard
union{
   difference{   
  union{   
   superellipsoid{<.1,.1> translate <0,1,1> scale <60,3,25>} 
   superellipsoid{<1,.1> rotate 90*y scale <60,3,6> translate <0,3,3>}
   superellipsoid{<1,.1> rotate 90*y scale <60,3,6> translate <0,3,47>} 
   superellipsoid{<.25,.25> translate <0,0,1> scale <10,3,25*sin(radians(10))+1.5> rotate 110*x translate <-40,3,50>}  
   superellipsoid{<.25,.25> translate <0,0,1> scale <10,3,25*sin(radians(10))+1.5> rotate 110*x translate <40,3,50>}
   } 
  union{
    superellipsoid{<.01,.01> scale <45,3,15> translate <-10,6,20>}
    superellipsoid{<.01,.01> scale <3,3,3> translate <-52,6,41>}
    superellipsoid{<.01,.01> scale <12,3,3> translate <-31,6,41>} 
    superellipsoid{<.01,.01> scale <12,3,3> translate <-4,6,41>} 
    superellipsoid{<.01,.01> scale <12,3,3> translate <23,6,41>}
    superellipsoid{<.01,.01> scale <9,3,3> translate <47,6,41>}
    superellipsoid{<.01,.01> scale <9,3,6> translate <47,6,29>}
    superellipsoid{<.01,.01> scale <9,3,3> translate <47,6,8>}
    superellipsoid{<.01,.01> scale <3,3,6> translate <47,6,11>}
   }
  }
 //keys
 union{                                       
  //row 1
  object{key scale <7,1,1> translate <-10,3,8>} 
  //row 2
  object{key translate <-40,3,14>}
  object{key translate <-34,3,14>}
  object{key translate <-28,3,14>} 
  object{key translate <-22,3,14>} 
  object{key translate <-16,3,14>}
  object{key translate <-10,3,14>}
  object{key translate <-4,3,14>} 
  object{key translate <2,3,14>}
  object{key translate <8,3,14>}
  object{key translate <14,3,14>}
  //row 3                  
  object{key translate <-43,3,20>}
  object{key translate <-37,3,20>}
  object{key translate <-31,3,20>}
  object{key translate <-25,3,20>}
  object{key translate <-19,3,20>}
  object{key translate <-13,3,20>} 
  object{key translate <-7,3,20>} 
  object{key translate <-1,3,20>}
  object{key translate <5,3,20>}
  object{key translate <11,3,20>}
  object{key translate <17,3,20>} 
  //row 4                
  object{key translate <-44.5,3,26>}
  object{key translate <-38.5,3,26>}
  object{key translate <-32.5,3,26>}
  object{key translate <-26.5,3,26>}
  object{key translate <-20.5,3,26>}
  object{key translate <-14.5,3,26>} 
  object{key translate <-8.5,3,26>} 
  object{key translate <-2.5,3,26>}
  object{key translate <3.5,3,26>}
  object{key translate <9.5,3,26>}
  object{key translate <15.5,3,26>}
  object{key translate <21.5,3,26>} 
  object{key scale <1.75,1,1> translate <29.75,3,26>}  
  //row 5
  object{key translate <-52,3,32>} 
  object{key translate <-46,3,32>}
  object{key translate <-40,3,32>}
  object{key translate <-34,3,32>}
  object{key translate <-28,3,32>}
  object{key translate <-22,3,32>}
  object{key translate <-16,3,32>}
  object{key translate <-10,3,32>}
  object{key translate <-4,3,32>}
  object{key translate <2,3,32>} 
  object{key translate <8,3,32>} 
  object{key translate <14,3,32>} 
  object{key translate <20,3,32>} 
  //row 6
  object{key translate <-40,3,41>}
  object{key translate <-34,3,41>}
  object{key translate <-28,3,41>}
  object{key translate <-22,3,41>}
  object{key translate <-13,3,41>}
  object{key translate <-7,3,41>}
  object{key translate <-1,3,41>}
  object{key translate <5,3,41>}
  object{key translate <14,3,41>}
  object{key translate <20,3,41>}
  object{key translate <26,3,41>}
  object{key translate <32,3,41>}
  //keypad
  object{key translate <41,3,41>} 
  object{key translate <47,3,41>}
  object{key translate <53,3,41>}
  object{key translate <41,3,32>} 
  object{key translate <47,3,32>}
  object{key translate <53,3,32>}
  object{key translate <41,3,26>} 
  object{key translate <47,3,26>}
  object{key translate <53,3,26>}
  pigment{color rgb <1.25,1.25,1.25>}
  }
 //special keys
 union{                                 
  //row 1
  object{key scale <2,1,1> translate <-49,3,8>} 
  object{key scale <2,1,1> translate <-37,3,8>}                               
  object{key scale <2,1,1> translate <29,3,8>} 
  object{key scale <2,1,1> translate <17,3,8>}  
  //row 2
  object{key scale <2,1,1> translate <-49,3,14>} 
  object{key scale <3,1,1> translate <26,3,14>}                             
  //row 3
  object{key scale <1.5,1,1> translate <-50.5,3,20>}
  object{key scale <2.5,1,1> translate <27.5,3,20>
         #if ((-4+7*(clock-1)*2) >= 0)
         translate (-((-4+7*(clock-1)*2)))*y
         #end
         }
  //row 4
  object{key scale <1.25,1,1> translate <-51.25,3,26>}
  //row 5
  object{key scale <2,1,1> translate <29,3,32>}
  //row 6
  object{key translate <-52,3,41>}
  //keypad
  object{key translate <47,3,14>}
  object{key translate <41,3,8>} 
  object{key translate <47,3,8>}
  object{key translate <53,3,8>}
  pigment{color Gray} 
  } 
 //key labels
 union{  
  //special Key labels
  text{ttf "cyrvetic.ttf" "Ctrl" .25,0 rotate 90*x scale <2,2,2> translate <-53,8.1,8>} 
  text{ttf "cyrvetic.ttf" "Alt" .25,0 rotate 90*x scale <2,2,2> translate <-41,8.1,8>}
  text{ttf "cyrvetic.ttf" "Ctrl" .25,0 rotate 90*x scale <2,2,2> translate <25,8.1,8>}
  text{ttf "cyrvetic.ttf" "Alt" .25,0 rotate 90*x scale <2,2,2> translate <15,8.1,8>} 
  text{ttf "cyrvetic.ttf" "Shift" .25,0 rotate 90*x scale <2,2,2> translate <-53,8.1,14>}  
  text{ttf "cyrvetic.ttf" "Shift" .25,0 rotate 90*x scale <2,2,2> translate <19.75,8.1,14>}
  text{ttf "cyrvetic.ttf" "Caps" .25,0 rotate 90*x scale <1.5,1.5,1.5> translate <-53.375,8.1,20+.5>}    
  text{ttf "cyrvetic.ttf" "Lock" .25,0 rotate 90*x scale <1.5,1.5,1.5> translate <-52.375,8.1,20-1>}  
  text{ttf "cyrvetic.ttf" "Enter" .25,0 rotate 90*x scale <2,2,2> translate <22.375,8.1,20>
       #if ((-4+7*(clock-1)*2) >= 0)
        translate (-((-4+7*(clock-1)*2)))*y
       #end 
       }  
  text{ttf "cyrvetic.ttf" "Tab" .25,0 rotate 90*x scale <2,2,2> translate <-53.5625,8.1,26>}
  text{ttf "cyrvetic.ttf" "Backspace" .25,0 rotate 90*x scale <1.5,1.5,1.5> translate <25,8.1,32>}
  text{ttf "cyrvetic.ttf" "Esc" .25,0 rotate 90*x scale <2,2,2> translate <-53.75,8.1,41>}   
  object{arrow rotate -90*y translate <41,8.1,8>}
  object{arrow rotate -180*y translate <47,8.1,8>} 
  object{arrow rotate 90*y translate <53,8.1,8>} 
  object{arrow translate <47,8.1,14>}
  //normal key labels 
  union{
   //row 2
   text{ttf "cyrvetic.ttf" "Z" .25,0 rotate 90*x scale <2.5,2.5,2.5> translate <-41.75,8.1,14>}
   text{ttf "cyrvetic.ttf" "X" .25,0 rotate 90*x scale <2.5,2.5,2.5> translate <-35.75,8.1,14>}
   text{ttf "cyrvetic.ttf" "C" .25,0 rotate 90*x scale <2.5,2.5,2.5> translate <-29.75,8.1,14>}
   text{ttf "cyrvetic.ttf" "V" .25,0 rotate 90*x scale <2.5,2.5,2.5> translate <-23.75,8.1,14>}
   text{ttf "cyrvetic.ttf" "B" .25,0 rotate 90*x scale <2.5,2.5,2.5> translate <-17.75,8.1,14>}
   text{ttf "cyrvetic.ttf" "N" .25,0 rotate 90*x scale <2.5,2.5,2.5> translate <-11.75,8.1,14>}
   text{ttf "cyrvetic.ttf" "M" .25,0 rotate 90*x scale <2.5,2.5,2.5> translate <-5.75,8.1,14>}
   text{ttf "cyrvetic.ttf" "<" .25,0 rotate 90*x scale <2,2,2> translate <.25,8.1,14+.5>}  
   text{ttf "cyrvetic.ttf" "," .25,0 rotate 90*x scale <2,2,2> translate <.25,8.1,14-1>} 
   text{ttf "cyrvetic.ttf" ">" .25,0 rotate 90*x scale <2,2,2> translate <6.25,8.1,14+.5>}  
   text{ttf "cyrvetic.ttf" "." .25,0 rotate 90*x scale <2,2,2> translate <6.25,8.1,14-1>}
   text{ttf "cyrvetic.ttf" "?" .25,0 rotate 90*x scale <2,2,2> translate <12.25,8.1,14+.75>}  
   text{ttf "cyrvetic.ttf" "/" .25,0 rotate 90*x scale <2,2,2> translate <12.25,8.1,14-1>} 
   //row 3 
   text{ttf "cyrvetic.ttf" "A" .25,0 rotate 90*x scale <2.5,2.5,2.5> translate <-44.75,8.1,20>} 
   text{ttf "cyrvetic.ttf" "S" .25,0 rotate 90*x scale <2.5,2.5,2.5> translate <-38.75,8.1,20>}
   text{ttf "cyrvetic.ttf" "D" .25,0 rotate 90*x scale <2.5,2.5,2.5> translate <-32.75,8.1,20>}
   text{ttf "cyrvetic.ttf" "F" .25,0 rotate 90*x scale <2.5,2.5,2.5> translate <-26.75,8.1,20>}
   text{ttf "cyrvetic.ttf" "G" .25,0 rotate 90*x scale <2.5,2.5,2.5> translate <-20.75,8.1,20>}
   text{ttf "cyrvetic.ttf" "H" .25,0 rotate 90*x scale <2.5,2.5,2.5> translate <-14.75,8.1,20>}
   text{ttf "cyrvetic.ttf" "J" .25,0 rotate 90*x scale <2.5,2.5,2.5> translate <-8.75,8.1,20>}  
   text{ttf "cyrvetic.ttf" "K" .25,0 rotate 90*x scale <2.5,2.5,2.5> translate <-2.75,8.1,20>} 
   text{ttf "cyrvetic.ttf" "L" .25,0 rotate 90*x scale <2.5,2.5,2.5> translate <3.25,8.1,20>} 
   text{ttf "cyrvetic.ttf" ":" .25,0 rotate 90*x scale <2,2,2> translate <9.25,8.1,20+.5>}  
   text{ttf "cyrvetic.ttf" ";" .25,0 rotate 90*x scale <2,2,2> translate <9.25,8.1,20-1>}
   text{ttf "cyrvetic.ttf" "*" .25,0 rotate 90*x scale <2,2,2> translate <15.25,8.1,20+.5>}  
   text{ttf "cyrvetic.ttf" "'" .25,0 rotate 90*x scale <2,2,2> translate <15.25,8.1,20-1.5>} 
   //row 4
   text{ttf "cyrvetic.ttf" "Q" .25,0 rotate 90*x scale <2.5,2.5,2.5> translate <-46.25,8.1,26>}  
   text{ttf "cyrvetic.ttf" "W" .25,0 rotate 90*x scale <2.5,2.5,2.5> translate <-40.25,8.1,26>}
   text{ttf "cyrvetic.ttf" "E" .25,0 rotate 90*x scale <2.5,2.5,2.5> translate <-34.25,8.1,26>}
   text{ttf "cyrvetic.ttf" "R" .25,0 rotate 90*x scale <2.5,2.5,2.5> translate <-28.25,8.1,26>}
   text{ttf "cyrvetic.ttf" "T" .25,0 rotate 90*x scale <2.5,2.5,2.5> translate <-22.25,8.1,26>}
   text{ttf "cyrvetic.ttf" "Y" .25,0 rotate 90*x scale <2.5,2.5,2.5> translate <-16.25,8.1,26>}
   text{ttf "cyrvetic.ttf" "U" .25,0 rotate 90*x scale <2.5,2.5,2.5> translate <-10.25,8.1,26>}
   text{ttf "cyrvetic.ttf" "I" .25,0 rotate 90*x scale <2.5,2.5,2.5> translate <-4.25,8.1,26>}
   text{ttf "cyrvetic.ttf" "O" .25,0 rotate 90*x scale <2.5,2.5,2.5> translate <1.75,8.1,26>}
   text{ttf "cyrvetic.ttf" "P" .25,0 rotate 90*x scale <2.5,2.5,2.5> translate <7.75,8.1,26>} 
   text{ttf "cyrvetic.ttf" "{" .25,0 rotate 90*x scale <2,2,2> translate <14.75,8.1,26+.75>}  
   text{ttf "cyrvetic.ttf" "[" .25,0 rotate 90*x scale <2,2,2> translate <13.75,8.1,26-1>} 
   text{ttf "cyrvetic.ttf" "}" .25,0 rotate 90*x scale <2,2,2> translate <19.75,8.1,26+.75>}  
   text{ttf "cyrvetic.ttf" "]" .25,0 rotate 90*x scale <2,2,2> translate <20.75,8.1,26-1>}
   text{ttf "cyrvetic.ttf" "|" .25,0 rotate 90*x scale <2,2,2> translate <27.75,8.1,26+.5>}  
   text{ttf "cyrvetic.ttf" "/" .25,0 rotate 90*x scale <2,2,2> translate <26.75,8.1,26-1>}  
   //row 5                                                                                 
   text{ttf "cyrvetic.ttf" "~" .25,0 rotate 90*x scale <2,2,2> translate <-53.75,8.1,32+.5>}  
   text{ttf "cyrvetic.ttf" "`" .25,0 rotate 90*x scale <2,2,2> translate <-53.75,8.1,32-1.5>} 
   text{ttf "cyrvetic.ttf" "!" .25,0 rotate 90*x scale <2,2,2> translate <-47.75,8.1,32+.75>}  
   text{ttf "cyrvetic.ttf" "1" .25,0 rotate 90*x scale <2,2,2> translate <-47.75,8.1,32-1.25>}
   text{ttf "cyrvetic.ttf" "@" .25,0 rotate 90*x scale <2,2,2> translate <-41.75,8.1,32+.75>}  
   text{ttf "cyrvetic.ttf" "2" .25,0 rotate 90*x scale <2,2,2> translate <-41.75,8.1,32-1.25>} 
   text{ttf "cyrvetic.ttf" "#" .25,0 rotate 90*x scale <2,2,2> translate <-35.75,8.1,32+.75>}  
   text{ttf "cyrvetic.ttf" "3" .25,0 rotate 90*x scale <2,2,2> translate <-35.75,8.1,32-1.25>} 
   text{ttf "cyrvetic.ttf" "$" .25,0 rotate 90*x scale <2,2,2> translate <-29.75,8.1,32+.75>}  
   text{ttf "cyrvetic.ttf" "4" .25,0 rotate 90*x scale <2,2,2> translate <-29.75,8.1,32-1.25>}
   text{ttf "cyrvetic.ttf" "%" .25,0 rotate 90*x scale <2,2,2> translate <-23.75,8.1,32+.75>}  
   text{ttf "cyrvetic.ttf" "5" .25,0 rotate 90*x scale <2,2,2> translate <-23.75,8.1,32-1.25>}
   text{ttf "cyrvetic.ttf" "^" .25,0 rotate 90*x scale <2,2,2> translate <-17.75,8.1,32+.75>}  
   text{ttf "cyrvetic.ttf" "6" .25,0 rotate 90*x scale <2,2,2> translate <-17.75,8.1,32-1.25>} 
   text{ttf "cyrvetic.ttf" "&" .25,0 rotate 90*x scale <2,2,2> translate <-11.75,8.1,32+.75>}  
   text{ttf "cyrvetic.ttf" "7" .25,0 rotate 90*x scale <2,2,2> translate <-11.75,8.1,32-1.25>}
   text{ttf "cyrvetic.ttf" "*" .25,0 rotate 90*x scale <2,2,2> translate <-5.75,8.1,32+.75>}  
   text{ttf "cyrvetic.ttf" "8" .25,0 rotate 90*x scale <2,2,2> translate <-5.75,8.1,32-1.25>} 
   text{ttf "cyrvetic.ttf" "(" .25,0 rotate 90*x scale <2,2,2> translate <.25,8.1,32+.75>}  
   text{ttf "cyrvetic.ttf" "9" .25,0 rotate 90*x scale <2,2,2> translate <.25,8.1,32-1.25>} 
   text{ttf "cyrvetic.ttf" ")" .25,0 rotate 90*x scale <2,2,2> translate <6.25,8.1,32+.75>}  
   text{ttf "cyrvetic.ttf" "0" .25,0 rotate 90*x scale <2,2,2> translate <6.25,8.1,32-1.25>}
   text{ttf "cyrvetic.ttf" "_" .25,0 rotate 90*x scale <2,2,2> translate <12.25,8.1,32+1>}  
   text{ttf "cyrvetic.ttf" "-" .25,0 rotate 90*x scale <2,2,2> translate <12.25,8.1,32-1.25>}
   text{ttf "cyrvetic.ttf" "+" .25,0 rotate 90*x scale <2,2,2> translate <18.25,8.1,32+.75>}  
   text{ttf "cyrvetic.ttf" "=" .25,0 rotate 90*x scale <2,2,2> translate <18.25,8.1,32-1.25>} 
   //top row
   text{ttf "cyrvetic.ttf" "F1" .25,0 rotate 90*x scale <2,2,2> translate <-41.75,8.1,41>} 
   text{ttf "cyrvetic.ttf" "F2" .25,0 rotate 90*x scale <2,2,2> translate <-35.75,8.1,41>} 
   text{ttf "cyrvetic.ttf" "F3" .25,0 rotate 90*x scale <2,2,2> translate <-29.75,8.1,41>} 
   text{ttf "cyrvetic.ttf" "F4" .25,0 rotate 90*x scale <2,2,2> translate <-23.75,8.1,41>} 
   text{ttf "cyrvetic.ttf" "F5" .25,0 rotate 90*x scale <2,2,2> translate <-14.75,8.1,41>} 
   text{ttf "cyrvetic.ttf" "F6" .25,0 rotate 90*x scale <2,2,2> translate <-8.75,8.1,41>} 
   text{ttf "cyrvetic.ttf" "F7" .25,0 rotate 90*x scale <2,2,2> translate <-2.75,8.1,41>} 
   text{ttf "cyrvetic.ttf" "F8" .25,0 rotate 90*x scale <2,2,2> translate <3.25,8.1,41>} 
   text{ttf "cyrvetic.ttf" "F9" .25,0 rotate 90*x scale <2,2,2> translate <12.25,8.1,41>} 
   text{ttf "cyrvetic.ttf" "F10" .25,0 rotate 90*x scale <2,2,2> translate <18.25,8.1,41>} 
   text{ttf "cyrvetic.ttf" "F11" .25,0 rotate 90*x scale <2,2,2> translate <24.25,8.1,41>} 
   text{ttf "cyrvetic.ttf" "F12" .25,0 rotate 90*x scale <2,2,2> translate <30.25,8.1,41>} 
   //keypad
   text{ttf "cyrvetic.ttf" "Print" .25,0 rotate 90*x scale <1,1,1> translate <39.25,8.1,41+.5>} 
   text{ttf "cyrvetic.ttf" "Screen" .25,0 rotate 90*x scale <1,1,1> translate <39.25,8.1,41-1>}
   text{ttf "cyrvetic.ttf" "Scroll" .25,0 rotate 90*x scale <1,1,1> translate <45.25,8.1,41+.5>} 
   text{ttf "cyrvetic.ttf" "Lock" .25,0 rotate 90*x scale <1,1,1> translate <45.25,8.1,41-1>} 
   text{ttf "cyrvetic.ttf" "Pause" .25,0 rotate 90*x scale <1,1,1> translate <51.25,8.1,41>} 
   text{ttf "cyrvetic.ttf" "Insert" .25,0 rotate 90*x scale <1,1,1> translate <39.25,8.1,32>} 
   text{ttf "cyrvetic.ttf" "Home" .25,0 rotate 90*x scale <1,1,1> translate <45.25,8.1,32>}
   text{ttf "cyrvetic.ttf" "Page" .25,0 rotate 90*x scale <1,1,1> translate <51.25,8.1,32+.5>}
   text{ttf "cyrvetic.ttf" "Up" .25,0 rotate 90*x scale <1,1,1> translate <51.25,8.1,32-1>} 
   text{ttf "cyrvetic.ttf" "Delete" .25,0 rotate 90*x scale <1,1,1> translate <39.25,8.1,26>} 
   text{ttf "cyrvetic.ttf" "End" .25,0 rotate 90*x scale <1,1,1> translate <45.25,8.1,26>}
   text{ttf "cyrvetic.ttf" "Page" .25,0 rotate 90*x scale <1,1,1> translate <51.25,8.1,26+.5>}
   text{ttf "cyrvetic.ttf" "Down" .25,0 rotate 90*x scale <1,1,1> translate <51.25,8.1,26-1>}
   translate <0,0,-.5>
   }
  pigment{color Black}
  }                      
 rotate -10*x                                               
 translate <60,-40,150>
 pigment{color White}
}
 
//alarm light
union{
 torus{10,2.5 rotate 90*x translate <0,100,300> pigment{color Black}}
 sphere{<0,0,0>,8 scale <1,1,0.5> translate <0,100,300> pigment{color Black}}
 cone{<0,0,0>,10,<0,0,-20>,7.5 translate <0,100,300> pigment{color rgbf <1,0,0,.5>} finish{ambient alarm}}
 sphere{<0,0,0>,7.5 scale <1,1,.5> translate <0,100,280> pigment{color rgbf <1,0,0,.5>} finish{ambient alarm}}
 #if (alarm = 1)
  light_source{<0,100,275> color rgb <2+2*cos(2*pi*clock),0,0>} 
 #end
 } 

object{arm translate <60,-40,150> translate <27.5,41,-19.5>}
